## ros-one-ros-type-introspection 2.1.0-5jammy.20251023.0012

=== debian/changelog ===
ros-one-ros-type-introspection (2.1.0-5jammy.20251023.0012) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 23 Oct 2025 00:12:11 +0000

ros-one-ros-type-introspection (2.1.0-0jammy) jammy; urgency=high

  * Removed flyweight and fixed potential conversion errors
  * Update README.md
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 03 Sep 2020 00:00:00 -0000

ros-one-ros-type-introspection (2.0.4-0jammy) jammy; urgency=high

  * Fix bug reported in plotjuggler
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 07 Nov 2019 00:00:00 -0000

ros-one-ros-type-introspection (2.0.3-0jammy) jammy; urgency=high

  * critical bug fix
  * fix warning
    Fix sign comparison warnings
  * Fixed -Wsign-compare warnings
  * Contributors: Davide Faconti, Jarvis Schultz

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 30 Oct 2019 00:00:00 -0000

ros-one-ros-type-introspection (2.0.2-0jammy) jammy; urgency=high

  * speed optimization (fix regression in 2.0)
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 01 Oct 2019 00:00:00 -0000

ros-one-ros-type-introspection (2.0.1-0jammy) jammy; urgency=high

  * fix (old abseil stuff)
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 01 Oct 2019 00:00:00 -0000

ros-one-ros-type-introspection (2.0.0-0jammy) jammy; urgency=high

  * removed abseil
  * Merge branch 'master' of https://github.com/facontidavide/ros_type_introspection
  * minor changes in the API
  * Fix issue #38 <https://github.com/facontidavide/ros_type_introspection/issues/38>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 01 Oct 2019 00:00:00 -0000

ros-one-ros-type-introspection (1.3.3-0jammy) jammy; urgency=high

  * fix issue #36 <https://github.com/facontidavide/ros_type_introspection/issues/36>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Fri, 10 May 2019 00:00:00 -0000

ros-one-ros-type-introspection (1.3.2-0jammy) jammy; urgency=high

  * fix issue #35 <https://github.com/facontidavide/ros_type_introspection/issues/35>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 17 Apr 2019 00:00:00 -0000

ros-one-ros-type-introspection (1.3.1-0jammy) jammy; urgency=high

  * Merge pull request #32 <https://github.com/facontidavide/ros_type_introspection/issues/32> from aeudes/fix_large_array
  * Fix invalid clamp and discard beaviour.
  * Contributors: Alexandre Eudes, Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Sun, 24 Mar 2019 00:00:00 -0000

ros-one-ros-type-introspection (1.3.0-0jammy) jammy; urgency=high

  * adding new policy
  * fix compiler warnings
  * added comment
  * Contributors: Davide Faconti, Robert Haschke, YiweiHan, janEbert

 -- Davide Faconti <davide.faconti@gmail.com>  Fri, 25 Jan 2019 00:00:00 -0000

ros-one-ros-type-introspection (1.2.0-0jammy) jammy; urgency=high

  * fixed -Wreorder (#24 <https://github.com/facontidavide/ros_type_introspection/issues/24>)
    * client code can now compile with -Werror
  * solved compilation problem when convert_impl<float, float>
  * Update README.md
  * Contributors: Davide Faconti, moooeeeep

 -- Davide Faconti <davide.faconti@gmail.com>  Mon, 12 Nov 2018 00:00:00 -0000

ros-one-ros-type-introspection (1.1.1-0jammy) jammy; urgency=high

  * split the project into two packages to reduce dependencies
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Sun, 15 Apr 2018 00:00:00 -0000

ros-one-ros-type-introspection (1.1.0-0jammy) jammy; urgency=high

  * critical bug fix
  * fixed compilation of test
  * remove potential problem in other projects
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 22 Mar 2018 00:00:00 -0000

ros-one-ros-type-introspection (1.0.2-0jammy) jammy; urgency=high

  * fixing issue with blobs (detected when parsing sensor_msgs::Image)
  * added test for sensor image
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 08 Feb 2018 00:00:00 -0000

ros-one-ros-type-introspection (1.0.1-0jammy) jammy; urgency=high

  * added return value to deserializeIntoFlatContainer
  * bug fix
  * fix compilation issue
  * fix potential issue with static variables
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 14 Nov 2017 00:00:00 -0000

ros-one-ros-type-introspection (1.0.0-0jammy) jammy; urgency=high

  * Complete refactoring
  * Contributors: Davide Faconti, Kartik Mohta, Ian Taylor, Mehdi Tlili

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 12 Oct 2017 00:00:00 -0000

ros-one-ros-type-introspection (0.8.0-0jammy) jammy; urgency=high

  * fixing a serious issue with vectors which are too large
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 30 Aug 2017 00:00:00 -0000

ros-one-ros-type-introspection (0.7.1-0jammy) jammy; urgency=high

  * ros Time and Duration fixed
  * tests fixed
  * important API Change
  * might fix issue reported in #5 <https://github.com/facontidavide/ros_type_introspection/issues/5>. print_number made public
  * adding inline to fix compilation error #4 <https://github.com/facontidavide/ros_type_introspection/issues/4>
  * maintain nanosecond precision for time/duration
  * Contributors: Davide Faconti, Ian Taylor

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 29 Aug 2017 00:00:00 -0000

ros-one-ros-type-introspection (0.6.3-0jammy) jammy; urgency=high

  * speed up
  * yet another bug fixed
  * considerable speed improvement
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Mon, 26 Jun 2017 00:00:00 -0000

ros-one-ros-type-introspection (0.6.2-0jammy) jammy; urgency=high

  * bug fix. types where missing in conversion


## ros-one-ros-type-introspection 2.1.0-5jammy.20260220.2112

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(ros_type_introspection)

find_package(Boost REQUIRED COMPONENTS regex)

find_package(catkin REQUIRED COMPONENTS 
   roscpp 
   rostime 
   roscpp_serialization
)

catkin_package(
   INCLUDE_DIRS include
   LIBRARIES ros_type_introspection
   CATKIN_DEPENDS 
   roscpp 
   rostime 
   roscpp_serialization
   DEPENDS 
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations

include_directories(
    include
    ${catkin_INCLUDE_DIRS}
)

## Declare a C++ library
 add_library(ros_type_introspection

   src/ros_type.cpp
   src/ros_field.cpp
   src/stringtree_leaf.cpp
   src/ros_message.cpp
   src/substitution_rule.cpp
   src/ros_introspection.cpp
 )

target_link_libraries(ros_type_introspection ${catkin_LIBRARIES})


#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executables and/or libraries for installation
install(TARGETS ros_type_introspection 
   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   RUNTIME DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
 )

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
   FILES_MATCHING PATTERN "*.hpp"
   PATTERN ".git" EXCLUDE
)

=== debian/changelog ===
ros-one-ros-type-introspection (2.1.0-5jammy.20260220.2112) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Davide Faconti <davide.faconti@gmail.com>  Fri, 20 Feb 2026 21:12:23 +0000

=== debian/control ===
Source: ros-one-ros-type-introspection
Section: misc
Priority: optional
Maintainer: Davide Faconti <davide.faconti@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-one-catkin, ros-one-roscpp, ros-one-roscpp-serialization, ros-one-rostime
Homepage: http://www.ros.org/wiki/ros_type_introspection
Standards-Version: 3.9.2

Package: ros-one-ros-type-introspection
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-one-roscpp, ros-one-roscpp-serialization, ros-one-rostime
Description: The ros_type_introspection package allows the user to parse and deserialize ROS messages which type is unknown at compilation time.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-ros-type-introspection//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-ros-type-introspection 2.1.0-5noble.20251023.0010

=== debian/changelog ===
ros-one-ros-type-introspection (2.1.0-5noble.20251023.0010) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 23 Oct 2025 00:10:58 +0000

ros-one-ros-type-introspection (2.1.0-0noble) noble; urgency=high

  * Removed flyweight and fixed potential conversion errors
  * Update README.md
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 03 Sep 2020 00:00:00 -0000

ros-one-ros-type-introspection (2.0.4-0noble) noble; urgency=high

  * Fix bug reported in plotjuggler
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 07 Nov 2019 00:00:00 -0000

ros-one-ros-type-introspection (2.0.3-0noble) noble; urgency=high

  * critical bug fix
  * fix warning
    Fix sign comparison warnings
  * Fixed -Wsign-compare warnings
  * Contributors: Davide Faconti, Jarvis Schultz

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 30 Oct 2019 00:00:00 -0000

ros-one-ros-type-introspection (2.0.2-0noble) noble; urgency=high

  * speed optimization (fix regression in 2.0)
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 01 Oct 2019 00:00:00 -0000

ros-one-ros-type-introspection (2.0.1-0noble) noble; urgency=high

  * fix (old abseil stuff)
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 01 Oct 2019 00:00:00 -0000

ros-one-ros-type-introspection (2.0.0-0noble) noble; urgency=high

  * removed abseil
  * Merge branch 'master' of https://github.com/facontidavide/ros_type_introspection
  * minor changes in the API
  * Fix issue #38 <https://github.com/facontidavide/ros_type_introspection/issues/38>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 01 Oct 2019 00:00:00 -0000

ros-one-ros-type-introspection (1.3.3-0noble) noble; urgency=high

  * fix issue #36 <https://github.com/facontidavide/ros_type_introspection/issues/36>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Fri, 10 May 2019 00:00:00 -0000

ros-one-ros-type-introspection (1.3.2-0noble) noble; urgency=high

  * fix issue #35 <https://github.com/facontidavide/ros_type_introspection/issues/35>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 17 Apr 2019 00:00:00 -0000

ros-one-ros-type-introspection (1.3.1-0noble) noble; urgency=high

  * Merge pull request #32 <https://github.com/facontidavide/ros_type_introspection/issues/32> from aeudes/fix_large_array
  * Fix invalid clamp and discard beaviour.
  * Contributors: Alexandre Eudes, Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Sun, 24 Mar 2019 00:00:00 -0000

ros-one-ros-type-introspection (1.3.0-0noble) noble; urgency=high

  * adding new policy
  * fix compiler warnings
  * added comment
  * Contributors: Davide Faconti, Robert Haschke, YiweiHan, janEbert

 -- Davide Faconti <davide.faconti@gmail.com>  Fri, 25 Jan 2019 00:00:00 -0000

ros-one-ros-type-introspection (1.2.0-0noble) noble; urgency=high

  * fixed -Wreorder (#24 <https://github.com/facontidavide/ros_type_introspection/issues/24>)
    * client code can now compile with -Werror
  * solved compilation problem when convert_impl<float, float>
  * Update README.md
  * Contributors: Davide Faconti, moooeeeep

 -- Davide Faconti <davide.faconti@gmail.com>  Mon, 12 Nov 2018 00:00:00 -0000

ros-one-ros-type-introspection (1.1.1-0noble) noble; urgency=high

  * split the project into two packages to reduce dependencies
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Sun, 15 Apr 2018 00:00:00 -0000

ros-one-ros-type-introspection (1.1.0-0noble) noble; urgency=high

  * critical bug fix
  * fixed compilation of test
  * remove potential problem in other projects
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 22 Mar 2018 00:00:00 -0000

ros-one-ros-type-introspection (1.0.2-0noble) noble; urgency=high

  * fixing issue with blobs (detected when parsing sensor_msgs::Image)
  * added test for sensor image
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 08 Feb 2018 00:00:00 -0000

ros-one-ros-type-introspection (1.0.1-0noble) noble; urgency=high

  * added return value to deserializeIntoFlatContainer
  * bug fix
  * fix compilation issue
  * fix potential issue with static variables
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 14 Nov 2017 00:00:00 -0000

ros-one-ros-type-introspection (1.0.0-0noble) noble; urgency=high

  * Complete refactoring
  * Contributors: Davide Faconti, Kartik Mohta, Ian Taylor, Mehdi Tlili

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 12 Oct 2017 00:00:00 -0000

ros-one-ros-type-introspection (0.8.0-0noble) noble; urgency=high

  * fixing a serious issue with vectors which are too large
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 30 Aug 2017 00:00:00 -0000

ros-one-ros-type-introspection (0.7.1-0noble) noble; urgency=high

  * ros Time and Duration fixed
  * tests fixed
  * important API Change
  * might fix issue reported in #5 <https://github.com/facontidavide/ros_type_introspection/issues/5>. print_number made public
  * adding inline to fix compilation error #4 <https://github.com/facontidavide/ros_type_introspection/issues/4>
  * maintain nanosecond precision for time/duration
  * Contributors: Davide Faconti, Ian Taylor

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 29 Aug 2017 00:00:00 -0000

ros-one-ros-type-introspection (0.6.3-0noble) noble; urgency=high

  * speed up
  * yet another bug fixed
  * considerable speed improvement
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Mon, 26 Jun 2017 00:00:00 -0000

ros-one-ros-type-introspection (0.6.2-0noble) noble; urgency=high

  * bug fix. types where missing in conversion


## ros-one-ros-type-introspection 2.1.0-5noble.20260220.2117

=== debian/changelog ===
ros-one-ros-type-introspection (2.1.0-5noble.20260220.2117) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Davide Faconti <davide.faconti@gmail.com>  Fri, 20 Feb 2026 21:17:52 +0000
